#include <windows.h>
#include <stdio.h>
#include <string.h>

#define SBUF 256

int isknj(int c)
{
  c &= 0xff;
  return((c>=0x81 && c<=0x9f) || (c>=0xe0 && c<=0xfc));
}

int isknj2(int c)
{
  c &= 0xff;
  return(c>=0x40 && c<=0xfc && c!=0x7f);
}

char *kstrchr(char *s, int c)
{
  while(*s) {
    if(isknj(*s) && *(s+1)) {
      s += 2;
      continue;
    }
    if(*s == c)
	return s;
    s++;
  }
  return NULL;
}

char *kstrrchr(char *s, int c)
{
  char *p;
  for(p=NULL; *s; s++) {
    if(isknj(*s) && *(s+1)) {
      s++;
      continue;
    }
    if(*s == c)
      p = s;
  }
  return p;
}

void getlongname(char *name)
{
  HANDLE hnd;
  WIN32_FIND_DATA ffd;

  char buff[SBUF];
  char *p, *fp;

  strcpy(buff, name);

  for(p = buff; *p; p++) {
    if(isknj(*p)) {
      p++; continue;
    }
    if(*p == '\\') *p = '/';
  }

  fp = buff;
  if(p = kstrrchr(fp, '/')) {
    p++;
    fp = p;
  }
  if(p = kstrrchr(fp, ':')) {
    p++;
    fp = p;
  }
  if(p = kstrrchr(fp, '.')) *p = '\0';
  strcpy(name, fp);

  if(SearchPath(NULL, name, ".exe", SBUF, buff, &fp)) {
    if ((hnd = FindFirstFile(buff, &ffd)) == NULL) {
      fprintf(stderr,"%s is not found.\n",buff);
      exit (100);
    }
    FindClose(hnd);
    
    strcpy(buff, ffd.cFileName);
    fp = buff;
    if(p = kstrrchr(fp, '.')) *p = '\0';
  }
  else {
    fprintf(stderr,"%s is not found.\n", name);
    exit (100);
  }
  strcpy(name, fp);
  return;
}
