#========================================================================
#
# FoFi library Makefile
#
# Copyright 2003 Glyph & Cog, LLC
#
#========================================================================

SHELL = sh

srcdir = .
VPATH = .

GOOSRCDIR = ../goo
GOOLIBDIR = ../goo

#CXXFLAGS = -DPDF_PARSER_ONLY=1 -DWIN32=1 -MD -nologo -O2 -QIfdiv- -I.. \
#-I$(GOOSRCDIR) -I$(srcdir)

CXXFLAGS = -DWIN32=1 -MD -nologo -O2 -QIfdiv- -I.. \
-I$(GOOSRCDIR) -I$(srcdir)

CXX = cl
AR = lib
RANLIB =

LIBPREFIX = lib

#------------------------------------------------------------------------

.SUFFIXES: .cc .obj

.cc.obj:
	$(CXX) $(CXXFLAGS) -c -Tp$<

#------------------------------------------------------------------------

CXX_SRC = \
	$(srcdir)/FoFiBase.cc \
	$(srcdir)/FoFiEncodings.cc \
	$(srcdir)/FoFiTrueType.cc \
	$(srcdir)/FoFiType1.cc \
	$(srcdir)/FoFiType1C.cc

#------------------------------------------------------------------------

all: $(LIBPREFIX)fofi.lib

#------------------------------------------------------------------------

FOFI_OBJS = \
	FoFiBase.obj \
	FoFiEncodings.obj \
	FoFiTrueType.obj \
	FoFiType1.obj \
	FoFiType1C.obj

$(LIBPREFIX)fofi.lib: $(FOFI_OBJS)
	rm -f $(LIBPREFIX)fofi.lib
	$(AR) -out:$(LIBPREFIX)fofi.lib $(FOFI_OBJS)

#------------------------------------------------------------------------

clean:
	rm -f $(FOFI_OBJS) $(LIBPREFIX)fofi.lib

#------------------------------------------------------------------------

depend:
	touch Makefile.dep
	makedepend -fMakefile.dep -o.obj --cpp=vc --cpp-bin=cl --newline=unix \
          -DWIN32=1 -I. -I.. -I../goo $(CXX_SRC)

include Makefile.dep
