#========================================================================
#
# Goo library Makefile
#
# Copyright 1996-2003 Glyph & Cog, LLC
#
#========================================================================

SHELL = sh

srcdir = .
VPATH = .

#CFLAGS = -DPDF_PARSER_ONLY=1 -DWIN32=1 -MD -nologo -O2 -QIfdiv- -I.. -I$(srcdir)
#CXXFLAGS = -DPDF_PARSER_ONLY=1 -DWIN32=1 -MD -nologo -O2 -QIfdiv- -TP -I.. \
#-I$(srcdir)

CFLAGS = -DWIN32=1 -MD -nologo -O2 -QIfdiv- -I.. -I$(srcdir)
CXXFLAGS = -DWIN32=1 -MD -nologo -O2 -QIfdiv- -TP -I.. \
-I$(srcdir)

CC = cl
CXX = cl
AR = lib
RANLIB =

LIBPREFIX = lib

#------------------------------------------------------------------------

.SUFFIXES: .cc .c

.cc.obj:
	$(CXX) $(CXXFLAGS) -c $<
.c.obj:
	$(CC) $(CFLAGS) -c $<

#------------------------------------------------------------------------

CXX_SRC = \
	$(srcdir)/GHash.cc \
	$(srcdir)/GList.cc \
	$(srcdir)/GString.cc \
	$(srcdir)/gmem.cc \
	$(srcdir)/gmempp.cc \
	$(srcdir)/gfile.cc \
	$(srcdir)/FixedPoint.cc

C_SRC = \
	$(srcdir)/parseargs.c

#------------------------------------------------------------------------

all: $(LIBPREFIX)Goo.lib

#------------------------------------------------------------------------

GOO_CXX_OBJS = GHash.obj GList.obj GString.obj gmem.obj gmempp.obj \
               gfile.obj FixedPoint.obj
GOO_C_OBJS = parseargs.obj
GOO_OBJS = $(GOO_CXX_OBJS) $(GOO_C_OBJS)

$(LIBPREFIX)Goo.lib: $(GOO_OBJS)
	rm -f $(LIBPREFIX)Goo.lib
	$(AR) -out:$(LIBPREFIX)Goo.lib $(GOO_OBJS)

#------------------------------------------------------------------------

clean:
	rm -f $(GOO_OBJS) $(LIBPREFIX)Goo.lib

#------------------------------------------------------------------------

depend:
	makedepend -fMakefile.dep -o.obj --cpp=vc --cpp-bin=cl --newline=unix \
         -DWIN32=1 -I.. -I. $(CXX_SRC) $(C_SRC)

include Makefile.dep
