#========================================================================
#
# Splash library Makefile
#
# Copyright 2003 Glyph & Cog, LLC
#
#========================================================================

SHELL = sh

srcdir = .
VPATH = .

GOOSRCDIR = ../goo
GOOLIBDIR = ../goo
FOFISRCDIR = ../fofi
FOFILIBDIR = ../fofi

#DEFS = -DPDF_PARSER_ONLY=1 -DWIN32=1 -I.. -I$(GOOSRCDIR) -I$(FOFISRCDIR) \
#-I$(srcdir) \
#-I../../freetype/include -I../../t1lib/lib/t1lib

DEFS = -DWIN32=1 -I.. -I$(GOOSRCDIR) -I$(FOFISRCDIR) \
-I$(srcdir) \
-I../../freetype/include -I../../t1lib/lib/t1lib

CXXFLAGS = -MD -O2 -nologo -QIfdiv- -TP $(DEFS)

CXX = cl
AR = lib
RANLIB =

LIBPREFIX = lib

#------------------------------------------------------------------------

.SUFFIXES: .cc

.cc.obj:
	$(CXX) $(CXXFLAGS) -c $<

#------------------------------------------------------------------------
#

CXX_SRC = \
	$(srcdir)/Splash.cc \
	$(srcdir)/SplashBitmap.cc \
	$(srcdir)/SplashClip.cc \
	$(srcdir)/SplashFTFont.cc \
	$(srcdir)/SplashFTFontEngine.cc \
	$(srcdir)/SplashFTFontFile.cc \
	$(srcdir)/SplashFont.cc \
	$(srcdir)/SplashFontEngine.cc \
	$(srcdir)/SplashFontFile.cc \
	$(srcdir)/SplashFontFileID.cc \
	$(srcdir)/SplashPath.cc \
	$(srcdir)/SplashPattern.cc \
	$(srcdir)/SplashScreen.cc \
	$(srcdir)/SplashState.cc \
	$(srcdir)/SplashT1Font.cc \
	$(srcdir)/SplashT1FontEngine.cc \
	$(srcdir)/SplashT1FontFile.cc \
	$(srcdir)/SplashXPath.cc \
	$(srcdir)/SplashXPathScanner.cc

#------------------------------------------------------------------------

all: $(LIBPREFIX)splash.lib

#------------------------------------------------------------------------
#

SPLASH_OBJS = \
	Splash.obj \
	SplashBitmap.obj \
	SplashClip.obj \
	SplashFTFont.obj \
	SplashFTFontEngine.obj \
	SplashFTFontFile.obj \
	SplashFont.obj \
	SplashFontEngine.obj \
	SplashFontFile.obj \
	SplashFontFileID.obj \
	SplashPath.obj \
	SplashPattern.obj \
	SplashScreen.obj \
	SplashState.obj \
	SplashT1Font.obj \
	SplashT1FontEngine.obj \
	SplashT1FontFile.obj \
	SplashXPath.obj \
	SplashXPathScanner.obj

$(LIBPREFIX)splash.lib: $(SPLASH_OBJS)
	rm -f $(LIBPREFIX)splash.lib
	$(AR) -out:$(LIBPREFIX)splash.lib $(SPLASH_OBJS)

#------------------------------------------------------------------------

clean:
	rm -f $(SPLASH_OBJS) $(LIBPREFIX)splash.lib

#------------------------------------------------------------------------

depend:
	makedepend -fMakefile.dep -o.obj --cpp=vc --newline=unix \
         $(DEFS) $(CXX_SRC)

include Makefile.dep
