#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef WIN32
#include <fcntl.h>
#include <io.h>
#include <malloc.h>
#endif

#include <kpathsea/kpathsea.h>

FILE *vfp,*afp=NULL;
char *atfmname,*vtfmname,*afmname,*vfname,*kanatfm;
int kanatume=-1,chotai=0,baseshift=0,minute=0;

FILE *vfopen();
void usage();

int
main(int argc, char **argv)
{
	int i,j;
	char *fpath;

#ifdef WIN32
	getlongname(argv[0]);
#endif
	kpse_set_progname(argv[0]);

	if (argc < 3) {
		usage();
		exit(0);
	}

	argv++;

	for (;**argv=='-';argv++) {
		switch ((*argv)[1]) {
		case 'k':
			if ((*argv)[2]!='\0') {
				kanatume = atoi(&(*argv)[2]);
			}
			else {
				kanatume = atoi(*(++argv));
			}
			break;
		case 'K':
			if ((*argv)[2]!='\0') {
				kanatfm = strdup(&(*argv)[2]);
			}
			else {
				kanatfm = strdup(*(++argv));
			}
			break;
		case 'C':
			chotai=1;
			break;
		case 'a':
			if ((*argv)[2]!='\0') {
				afmname = strdup(&(*argv)[2]);
			}
			else {
				afmname = strdup(*(++argv));
			}
			if ((fpath=kpse_find_file(afmname,
			     kpse_afm_format, 0))==NULL) {
				fprintf(stderr,"no AFM file, %s.\n",afmname);
#ifdef WIN32
				exit(100);
#else
				exit(-1);
#endif
			}
			afp = fopen(fpath, "r");
			free(fpath);
			break;
		case 'b':
			if ((*argv)[2]!='\0') {
				baseshift = atoi(&(*argv)[2]);
			}
			else {
				baseshift = atoi(*(++argv));
			}
			break;
		case 'm':
			minute=1;
			break;
		default:
			usage();
			exit(0);
		}
	}

	if (kanatume>=0 && !afp) {
		fprintf(stderr,"No AFM file for kanatume.\n");
#ifdef WIN32
		exit(100);
#else
		exit(-1);
#endif
	}

	atfmname = malloc(strlen(*argv)+4);
	strcpy(atfmname,*argv);

	vfname = malloc(strlen(*argv)+4);
	strcpy(vfname,*argv);
	for (i = strlen(vfname)-1 ; i >= 0 ; i--) {
#ifdef WIN32
		if ((vfname[i] == '/') || (vfname[i] == '\\')) {
#else
		if (vfname[i] == '/') {
#endif
			vfname = &vfname[i+1];
			break;
		}
	}
	fpath = strrchr(vfname, '.');
#ifdef WIN32
	if (fpath && !stricmp(&vfname[strlen(vfname)-4],".tfm")) {
#else
	if (fpath && !strcmp(&vfname[strlen(vfname)-4],".tfm")) {
#endif
		vfname[strlen(vfname)-4] = '\0';
	}
	strcat(vfname,".vf");

	argv++;

	vtfmname = strdup(*argv);
	fpath = strrchr(vtfmname, '.');
#ifdef WIN32
	if (fpath && !stricmp(&vtfmname[strlen(vtfmname)-4],".tfm")) {
#else
	if (fpath && !strcmp(&vtfmname[strlen(vtfmname)-4],".tfm")) {
#endif
		vtfmname[strlen(vtfmname)-4] = '\0';
	}

	tfmget(atfmname);

	maketfm(vtfmname);

	if (kanatfm) {
	        fpath = strrchr(kanatfm, '.');
#ifdef WIN32
		if (fpath && !stricmp(&kanatfm[strlen(kanatfm)-4],".tfm")) {
#else
		if (fpath && !strcmp(&kanatfm[strlen(kanatfm)-4],".tfm")) {
#endif
			kanatfm[strlen(kanatfm)-4] = '\0';
		}
		maketfm(kanatfm);
	}

	vfp = vfopen(vfname);

	for (i=0;i<94;i++)
/*	for (i=0;i<120;i++) */
		for (j=0;j<94;j++)
			writevf((0x21+i)*256+(0x21+j),vfp);

	vfclose(vfp);

	return 0;
}

void
usage(void)
{
	fprintf(stderr,"MAKEJVF ver.1.1a -- make Japanese VF file.\n");
	fprintf(stderr,"%% makejvf [<options>] <TFMfile> <PSfontTFM>\n");
	fprintf(stderr,"options:\n");
	fprintf(stderr,"-C           ̃[h\n");
	fprintf(stderr,"-K <TFMfile> 񊿎pɍ쐬PStHgTFM\n");
	fprintf(stderr,"-b <l>    x[XC␳\n");
	fprintf(stderr,"             ̍1000ƂĐŎw\n");
	fprintf(stderr,"             vXŕA}CiXŕオ\n");
	fprintf(stderr,"-m           cɃNI[g(fh)̑Ƀ~j[g()gp\n");
	fprintf(stderr,"-a <AFMfile> AFMt@CiȋlߎɎgpj\n");
	fprintf(stderr,"-k <l>    ȋl߃}[Ww\n");
	fprintf(stderr,"             1000ƂĐŎwB-aIvVƋɎgp\n");
}
