/* 
   copy runscr.exe to script.exe,
   then script.exe ... actually execute "perl script.pl ..."
   (2000/03/26 --ak)
   generalized to execute ruby and python script.
   scripts can also be found in $TEXMF/scripts/
   (2004/10/16 --ak)
   if the first line is
   #!prog a b c ...
   run prog a b c ... scriptname args
   else prog is determined from the suffix of the script.
   (2005/02/24 --ak)
   add lua
   (2006/01/29 --ak)
*/

#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <malloc.h>
#include <process.h>
#include <kpathsea/kpathsea.h>

/*
char *kstrchr(char *s, int c)
{
  while(*s) {
    if(isknj(*s) && *(s+1)) {
      s += 2;
      continue;
    }
    if(*s == c)
	return s;
    s++;
  }
  return NULL;
}
*/

/*
char *kstrrchr(char *s, int c)
{
  char *p;
  for(p=NULL; *s; s++) {
    if(isknj(*s) && *(s+1)) {
      s++;
      continue;
    }
    if(*s == c)
      p = s;
  }
  return p;
}
*/

#define SBUF   256
#define LBUF   1024
#define MAXARG 1024

char path[SBUF];

char *getlname(char *name)
{
  HANDLE hnd;
  WIN32_FIND_DATA ffd;

  char buff[SBUF];
  char *p, *fp;

  strcpy(buff, name);
  for(p = buff; *p; p++) {
    if(isknj(*p)) {
      if(*(p+1)) p++;
      continue;
    }
    if(*p == '\\') *p = '/';
  }
  fp = buff;
  if(p = kstrrchr(fp, '/')) {
    p++;
    fp = p;
  }
  if(p = kstrrchr(fp, ':')) {
    p++;
    fp = p;
  }
  if(p = kstrrchr(fp, '.')) *p = '\0';
  strcpy(name, fp);

  if(SearchPath(NULL, name, ".exe", SBUF, buff, &fp)) {
    if ((hnd = FindFirstFile(buff, &ffd)) == NULL) {
      return NULL;
    }
    FindClose(hnd);

    strcpy(path, buff);
    for(p=path; *p; p++) {
      if(isknj(*p)) {
	if(*(p+1)) p++;
        continue;
      }
      if(*p == '\\') *p = '/';
    }
    if(p = kstrrchr(path, '/')) *p = '\0';

    strcpy(buff, ffd.cFileName);
    fp = buff;
    if(p = kstrrchr(fp, '.')) *p = '\0';
  }
  else {
    return NULL;
  }
  strcpy(name, fp);
  return (p = path);
}

int main(int ac, char **av)
{
  int i, ret;
  char *argv[MAXARG];
  char *p, *q;
  char scrname[SBUF];
  char fname[SBUF];
  FILE *f;
  char option[LBUF];
  char *fullname;
  int  interpreter;
  char cmdname[128];
  char cmdname2[128];
  int  use1stline = 0;

  getlongname(av[0]);
  kpse_set_progname(av[0]);
  cmdname[0] = '\0';
  cmdname2[0] = '\0';

  if(ac>MAXARG - 5) {
    fprintf(stderr, "Too many arguments.\n");
    exit (100);
  }

  for(i=0; i < ac + 2; i++)
    argv[i] = (char *)malloc(128);

  p = getlname(av[0]);
  if(!p) {
    fprintf(stderr, "Failed to find script loader.\n");
    for(i=0; i < ac + 2; i++)
      free(argv[i]);
    exit (100);
  }

  scrname[0] = '\0';

/* first search for script in the bin directory */
/* perl or generic (no suffix, .pl, .plx, .scr) */
  interpreter = 0;
  strcpy(fname, p);
  strcat(fname, "/");
  strcat(fname, av[0]);
  if(_access(fname, 0) == 0)
    strcpy(scrname, fname);

  if(!scrname[0]) {
    strcat(fname, ".pl");
    if(_access(fname, 0) == 0)
      strcpy(scrname, fname);
  }

  if(!scrname[0]) {
    strcat(fname, "x");
    if(_access(fname,0) == 0)
      strcpy(scrname, fname);
  }

  if(!scrname[0]) {
    strcpy(fname, p);
    strcat(fname, "/");
    strcat(fname, av[0]);
    strcat(fname, ".scr");
    if(_access(fname,0) == 0)
      strcpy(scrname, fname);
  }


/* ruby (suffix .rb) */
  if(!scrname[0]) {
    strcpy(fname, p);
    strcat(fname, "/");
    strcat(fname, av[0]);
    strcat(fname, ".rb");
    if(_access(fname, 0) == 0) {
      strcpy(scrname, fname);
      interpreter = 1;
    }
  }


/* python (suffix .py) */
  if(!scrname[0]) {
    strcpy(fname, p);
    strcat(fname, "/");
    strcat(fname, av[0]);
    strcat(fname, ".py");
    if(_access(fname, 0) == 0) {
      strcpy(scrname, fname);
      interpreter = 2;
    }
  }

/* lua (suffix .lua) */
  if(!scrname[0]) {
    strcpy(fname, p);
    strcat(fname, "/");
    strcat(fname, av[0]);
    strcat(fname, ".lua");
    if(_access(fname, 0) == 0) {
      strcpy(scrname, fname);
      interpreter = 3;
    }
  }

/* search script under $TEXMF/scripts */
/* perl */
  if(!scrname[0]) {
    strcpy(fname, av[0]);
    strcat(fname, ".pl");
    fullname = kpse_find_file(fname, kpse_texmfscripts_format, 1);
    if(fullname) {
      strcpy(scrname, fullname);
      free(fullname);
      interpreter = 0;
    }
  }

/* ruby */
  if(!scrname[0]) {
    strcpy(fname, av[0]);
    strcat(fname, ".rb");
    fullname = kpse_find_file(fname, kpse_texmfscripts_format, 1);
    if(fullname) {
      strcpy(scrname, fullname);
      free(fullname);
      interpreter = 1;
    }
  }

/* python */
  if(!scrname[0]) {
    strcpy(fname, av[0]);
    strcat(fname, ".py");
    fullname = kpse_find_file(fname, kpse_texmfscripts_format, 1);
    if(fullname) {
      strcpy(scrname, fullname);
      free(fullname);
      interpreter = 2;
    }
  }

/* lua */
  if(!scrname[0]) {
    strcpy(fname, av[0]);
    strcat(fname, ".lua");
    fullname = kpse_find_file(fname, kpse_texmfscripts_format, 1);
    if(fullname) {
      strcpy(scrname, fullname);
      free(fullname);
      interpreter = 3;
    }
  }

/* general suffix .scr (assume perl) */
  if(!scrname[0]) {
    strcpy(fname, av[0]);
    strcat(fname, ".scr");
    fullname = kpse_find_file(fname, kpse_texmfscripts_format, 1);
    if(fullname) {
      strcpy(scrname, fullname);
      free(fullname);
      interpreter = 0;
    }
  }

/* no suffix (assume perl) */
  if(!scrname[0]) {
    strcpy(fname, av[0]);
    fullname = kpse_find_file(fname, kpse_texmfscripts_format, 1);
    if(fullname) {
      strcpy(scrname, fullname);
      free(fullname);
      interpreter = 0;
    }
  }

  if(!scrname[0]) {
    fprintf(stderr, "Failed to find script.\n");
    for(i=0; i < ac + 2; i++)
      free(argv[i]);
    exit (100);
  }

/* read the first line of the script */
  f = fopen(scrname, "r");
  if(!f) {
    fprintf(stderr, "No script.\n");
    for(i=0; i < ac + 2; i++)
      free(argv[i]);
    exit (100);
  }

  for(i=0; i < LBUF; i++)
    option[i] = '\0';

  fgets(option, LBUF-1, f);
  fclose(f);
  i = strlen(option);
  if(option[i-1] == '\n') option[i-1] = '\0';

  strcpy(argv[1], " ");

  if(*option == '#' && *(option + 1) == '!') {
    p = option + 2;
    while(*p == ' ' || *p == '\t')
      p++;
    if(*p) {
      use1stline = 1;
      q = p;
      while(*p != ' ' && *p != '\t' && *p != '\0')
	p++;
      *p = '\0';
      strcpy(cmdname2, q);
      q = strrchr(cmdname2, '/');
      if (q) q++;
      else q = cmdname2;
      strcpy(cmdname, q);
      if(stricmp(cmdname, "env") == 0) {
	p++;
	while(*p == ' ' || *p == '\t')
	  p++;
	q = p;
	while(*p != ' ' && *p != '\t' && *p != '\0')
	  p++;
	*p = '\0';
	if(*q == '\0')
	  use1stline = 0;
	else
	  strcpy(cmdname, q);
      }
      p++;
      if(*p)
	strcpy(argv[1], p);
    }
  }

  if(!use1stline) {
    if(interpreter == 0)
      strcpy(cmdname, "perl.exe");
    else if(interpreter == 1)
      strcpy(cmdname, "ruby.exe");
    else if(interpreter == 2)
      strcpy(cmdname, "python.exe");
    else if(interpreter == 3)
      strcpy(cmdname, "lua.exe");
    else {
      fprintf(stderr, "Unknown interpreter.\n");
      exit(100);
    }
  }

  if(!getlname(cmdname)) {
    fprintf(stderr, "Script interpreter is not found in PATH.\n");
    exit (100);
  }

  strcpy(argv[0], cmdname);
  strcpy(argv[2], scrname);

  for(i=1; i < ac; i++)
    strcpy(argv[i+2], av[i]);
  argv[ac+2] = NULL;


/*
  for(i=0; i < ac + 2; i++)
    fprintf(stderr, "%s ", argv[i]);
  fprintf(stderr, "\n");
  return (0);
*/


  ret = spawnvp(_P_WAIT, cmdname, argv);

  for(i=0; i < ac + 2; i++)
    free(argv[i]);
  return ret;
}
