/* 
  context.c
*/

#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <malloc.h>
#include <process.h>
#include <kpathsea/kpathsea.h>

#define SBUF 256
#define LBUF 1024

char path[SBUF];

char *getlname(char *name)
{
  HANDLE hnd;
  WIN32_FIND_DATA ffd;

  char buff[SBUF];
  char *p, *fp;

  strcpy(buff, name);
  for(p = buff; *p; p++) {
    if(isknj(*p)) {
      if(*(p+1)) p++;
      continue;
    }
    if(*p == '\\') *p = '/';
  }
  fp = buff;
  if(p = kstrrchr(fp, '/')) {
    p++;
    fp = p;
  }
  if(p = kstrrchr(fp, ':')) {
    p++;
    fp = p;
  }
  if(p = kstrrchr(fp, '.')) *p = '\0';
  strcpy(name, fp);

  if(SearchPath(NULL, name, ".exe", SBUF, buff, &fp)) {
    if ((hnd = FindFirstFile(buff, &ffd)) == NULL) {
      return NULL;
    }
    FindClose(hnd);

    strcpy(path, buff);
    for(p=path; *p; p++) {
      if(isknj(*p)) {
	if(*(p+1)) p++;
        continue;
      }
      if(*p == '\\') *p = '/';
    }
    if(p = kstrrchr(path, '/')) *p = '\0';

    strcpy(buff, ffd.cFileName);
    fp = buff;
    if(p = kstrrchr(fp, '.')) *p = '\0';
  }
  else {
    return NULL;
  }
  strcpy(name, fp);
  return (p = path);
}

int main(int ac, char **av)
{
  int i, ret;
  char *argv[100];
  char *p, *q;
  char scrname[SBUF];
  char fname[SBUF];
  FILE *f;
  char option[LBUF];
  char *fullname;
  int  interpreter;
  char cmdname[128];
  char cmdname2[128];
  int  use1stline = 0;

  char *t1, *t2, *t3, *t4;

  getlongname(av[0]);
  kpse_set_progname(av[0]);
  cmdname[0] = '\0';
  cmdname2[0] = '\0';

  if(ac>95) {
    fprintf(stderr, "Too many arguments.\n");
    exit (100);
  }

  for(i=0; i < ac + 4; i++)
    argv[i] = (char *)malloc(128);

  p = getlname(av[0]);
  if(!p) {
    fprintf(stderr, "Failed to find script loader.\n");
    for(i=0; i < ac + 4; i++)
      free(argv[i]);
    exit (100);
  }

/* env variables for ConTeXt MKIV */

/* OSFONTDIR */
  t1 = getenv("SYSTEMROOT");
  if(t1) {
     for(t2=t1; *t2; t2++) {
	if(*t2 == '\\') *t2 = '/';
     }
     t2 = (char *)xmalloc(strlen(t1)+strlen("/fonts//")+2);
     strcpy(t2, t1);
     strcat(t2, "/fonts//");
     xputenv("OSFONTDIR", t2);
     free(t1);
     free(t2);
  } else {
     xputenv("OSFONTDIR", "c:/windows/fonts//");
  }

/* TEXMFCACHE */
  t1 = NULL;
  t2 = kpse_var_value("TEXMFCACHE");
  if(t2) {
    t1 = kpse_brace_expand(t2);
    free(t2);
    t2 = strchr(t1, ';');
    if(t2) *t2 = '\0';
  }
  if(!t1) {
    t1 = getenv("TEMP");
    if(!t1) t1 = getenv("TMP");
    if(!t1) t1 = getenv("TMPDIR");
    if(!t1) {
      fprintf(stderr, "Define TEMP or TMP or TMPDIR\n");
      exit(100);
    }
  }
  for(t2=t1; *t2; t2++) {
     if(isknj(*t2)) {
	if(*(t2+1)) t2++;
	continue;
     }
     if(*t2 == '\\') *t2='/';
  }
  xputenv("TEXMFCACHE", t1);
  free(t1);

/* TEXMFCNF */
  t1 = kpse_var_value("TEXMFCNF");
  if(!t1) {
     fprintf(stderr, "I cannot determine TEXMFCNF\n");
     exit(100);
  }
  t2 = kpse_brace_expand(t1);
  free(t1);
  t1 = (char *)xmalloc(strlen(t2) + 3);
  t3 = t1;
  *t3++ = '{';
  for(t4=t2; *t4; t4++) {
     if(isknj(*t4)) {
	if(*(t4+1)) t4++;
	continue;
     }
     if(*t4 == '!')
	continue;
     if(*t4 == ';') {
	*t3++ = ',';
	continue;
     }
     *t3++ = *t4;
  }
  *t3++ = '}';
  *t3 = '\0';
  xputenv("TEXMFCNF", t1);
  free(t1);
  free(t2);

/* TEXMF */
  t1 = kpse_var_value("TEXMF");
  if(!t1) {
     fprintf(stderr, "I cannot determine TEXMF\n");
     exit(100);
  }
  t2 = kpse_brace_expand(t1);
  free(t1);
  t1 = (char *)xmalloc(strlen(t2) + 3);
  t3 = t1;
  *t3++ = '{';
  for(t4=t2; *t4; t4++) {
     if(isknj(*t4)) {
	if(*(t4+1)) t4++;
	continue;
     }
     if(*t4 == '!')
	continue;
     if(*t4 == ';') {
	*t3++ = ',';
	continue;
     }
     *t3++ = *t4;
  }
  *t3++ = '}';
  *t3 = '\0';
  xputenv("TEXMF", t1);
  free(t1);
  free(t2);

  scrname[0] = '\0';

  if(!scrname[0]) {
    strcpy(fname, p);
    strcat(fname, "/");
    strcat(fname, "mtxrun.lua");
    if(_access(fname, 0) == 0) {
      strcpy(scrname, fname);
      interpreter = 3;
    }
  }

  if(!scrname[0]) {
    strcpy(fname, "mtxrun.lua");
    fullname = kpse_find_file(fname, kpse_texmfscripts_format, 1);
    if(!fullname)
      fullname = kpse_find_file(fname, kpse_lua_format, 1);
    if(fullname) {
      strcpy(scrname, fullname);
      free(fullname);
      interpreter = 3;
    } else {
      fprintf(stderr, "I cannot find mtxrun.lua.\n");
      for(i=0; i < ac + 4; i++)
	free(argv[i]);
      exit (100);
    }
  }

  if(!scrname[0]) {
    fprintf(stderr, "Failed to find script.\n");
    for(i=0; i < ac + 4; i++)
      free(argv[i]);
    exit (100);
  }

/* read the first line of the script */
  f = fopen(scrname, "r");
  if(!f) {
    fprintf(stderr, "No script.\n");
    for(i=0; i < ac + 4; i++)
      free(argv[i]);
    exit (100);
  }

  for(i=0; i < LBUF; i++)
    option[i] = '\0';

  fgets(option, LBUF-1, f);
  fclose(f);
  i = strlen(option);
  if(option[i-1] == '\n') option[i-1] = '\0';

  strcpy(argv[1], " ");

  if(*option == '#' && *(option + 1) == '!') {
    p = option + 2;
    while(*p == ' ' || *p == '\t')
      p++;
    if(*p) {
      use1stline = 1;
      q = p;
      while(*p != ' ' && *p != '\t' && *p != '\0')
	p++;
      *p = '\0';
      strcpy(cmdname2, q);
      q = strrchr(cmdname2, '/');
      if (q) q++;
      else q = cmdname2;
      strcpy(cmdname, q);
      if(stricmp(cmdname, "env") == 0) {
	p++;
	while(*p == ' ' || *p == '\t')
	  p++;
	q = p;
	while(*p != ' ' && *p != '\t' && *p != '\0')
	  p++;
	*p = '\0';
	if(*q == '\0')
	  use1stline = 0;
	else
	  strcpy(cmdname, q);
      }
      p++;
      if(*p)
	strcpy(argv[1], p);
    }
  }

  if(!use1stline) {
    strcpy(cmdname, "texlua.exe");
  }

  if(!getlname(cmdname)) {
    fprintf(stderr, "Script interpreter is not found in PATH.\n");
    exit (100);
  }

  strcpy(argv[0], cmdname);
  strcpy(argv[2], scrname);
  strcpy(argv[3], "--script");
  strcpy(argv[4], "context");

  for(i=1; i < ac; i++)
    strcpy(argv[i+4], av[i]);
  argv[ac+4] = NULL;


/*
  for(i=0; i < ac + 4; i++)
    fprintf(stderr, "%s ", argv[i]);
  fprintf(stderr, "\n");
  return (0);
*/


  ret = spawnvp(_P_WAIT, cmdname, argv);

  for(i=0; i < ac + 4; i++)
    free(argv[i]);
  return ret;
}
