/* 
   copy runscr4ctx.exe to script.exe,
   then script.exe ... actually execute "perl script.pl ..."
   (2000/03/26 --ak)
   generalized to execute ruby and python script.
   scripts can also be found in $TEXMF/scripts/
   (2004/10/16 --ak)
   if the first line is
   #!prog a b c ...
   run prog a b c ... scriptname args
   else prog is determined from the suffix of the script.
   (2005/02/24 --ak)
   add lua
   (2006/01/29 --ak)
   special version for ConTeXt
   (2007/08/11 --ak)
   (2009/04/29 --ak)
*/

#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <malloc.h>
#include <process.h>
#include <kpathsea/kpathsea.h>

/*
char *kstrchr(char *s, int c)
{
  while(*s) {
    if(isknj(*s) && *(s+1)) {
      s += 2;
      continue;
    }
    if(*s == c)
	return s;
    s++;
  }
  return NULL;
}
*/

/*
char *kstrrchr(char *s, int c)
{
  char *p;
  for(p=NULL; *s; s++) {
    if(isknj(*s) && *(s+1)) {
      s++;
      continue;
    }
    if(*s == c)
      p = s;
  }
  return p;
}
*/

#define SBUF    256
#define MAXARG  512

char path[SBUF];

char *getlname(char *name)
{
  HANDLE hnd;
  WIN32_FIND_DATA ffd;

  char buff[SBUF];
  char *p, *fp;

  strcpy(buff, name);
  for(p = buff; *p; p++) {
    if(isknj(*p)) {
      if(*(p+1)) p++;
      continue;
    }
    if(*p == '\\') *p = '/';
  }
  fp = buff;
  if(p = kstrrchr(fp, '/')) {
    p++;
    fp = p;
  }
  if(p = kstrrchr(fp, ':')) {
    p++;
    fp = p;
  }
  if(p = kstrrchr(fp, '.')) *p = '\0';
  strcpy(name, fp);

  if(SearchPath(NULL, name, ".exe", SBUF, buff, &fp)) {
    if ((hnd = FindFirstFile(buff, &ffd)) == NULL) {
      return NULL;
    }
    FindClose(hnd);

    strcpy(path, buff);
    for(p=path; *p; p++) {
      if(isknj(*p)) {
	if(*(p+1)) p++;
        continue;
      }
      if(*p == '\\') *p = '/';
    }
    if(p = kstrrchr(path, '/')) *p = '\0';

    strcpy(buff, ffd.cFileName);
    fp = buff;
    if(p = kstrrchr(fp, '.')) *p = '\0';
  }
  else {
    return NULL;
  }
  strcpy(name, fp);
  return (p = path);
}

int main(int ac, char **av)
{
  int i, ret;
  char *argv[MAXARG];
  char *p;
  char scrname[SBUF];
  char fname[SBUF];
  FILE *f;
  char *fullname;
  char cmdname[SBUF];

  char *t1, *t2, *t3, *t4;
  int  kind = 0;

  getlongname(av[0]);
  kpse_set_progname(av[0]);
  cmdname[0] = '\0';

  if(ac>MAXARG - 5) {
    fprintf(stderr, "Too many arguments.\n");
    exit (100);
  }

  for(i=0; i < ac + 4; i++)
    argv[i] = (char *)malloc(SBUF);

  p = getlname(av[0]);
  if(!p) {
    fprintf(stderr, "Failed to find script loader.\n");
    for(i=0; i < ac + 2; i++)
      free(argv[i]);
    exit (100);
  }

/* env variables for ConTeXt MKIV */

/* OSFONTDIR */
  t1 = getenv("SYSTEMROOT");
  if(t1) {
     for(t2=t1; *t2; t2++) {
	if(*t2 == '\\') *t2 = '/';
     }
     t2 = (char *)xmalloc(strlen(t1)+strlen("/fonts//")+2);
     strcpy(t2, t1);
     strcat(t2, "/fonts//");
     xputenv("OSFONTDIR", t2);
     free(t1);
     free(t2);
  } else {
     xputenv("OSFONTDIR", "c:/windows/fonts//");
  }

/* TEXMFCACHE */
  t1 = NULL;
  t2 = kpse_var_value("TEXMFCACHE");
  if(t2) {
    t1 = kpse_brace_expand(t2);
    free(t2);
    t2 = strchr(t1, ';');
    if(t2) *t2 = '\0';
  }
  if(!t1) {
    t1 = getenv("TEMP");
    if(!t1) t1 = getenv("TMP");
    if(!t1) t1 = getenv("TMPDIR");
    if(!t1) {
      fprintf(stderr, "Define TEMP or TMP or TMPDIR\n");
      exit(100);
    }
  }
  for(t2=t1; *t2; t2++) {
     if(isknj(*t2)) {
	if(*(t2+1)) t2++;
	continue;
     }
     if(*t2 == '\\') *t2='/';
  }
  xputenv("TEXMFCACHE", t1);
  free(t1);

/* TEXMFCNF */
  t1 = kpse_var_value("TEXMFCNF");
  if(!t1) {
     fprintf(stderr, "I cannot determine TEXMFCNF\n");
     exit(100);
  }
  t2 = kpse_brace_expand(t1);
  free(t1);
  t1 = (char *)xmalloc(strlen(t2) + 3);
  t3 = t1;
  *t3++ = '{';
  for(t4=t2; *t4; t4++) {
     if(isknj(*t4)) {
	if(*(t4+1)) t4++;
	continue;
     }
     if(*t4 == '!')
	continue;
     if(*t4 == ';') {
	*t3++ = ',';
	continue;
     }
     *t3++ = *t4;
  }
  *t3++ = '}';
  *t3 = '\0';
  xputenv("TEXMFCNF", t1);
  free(t1);
  free(t2);

/* TEXMF */
  t1 = kpse_var_value("TEXMF");
  if(!t1) {
     fprintf(stderr, "I cannot determine TEXMF\n");
     exit(100);
  }
  t2 = kpse_brace_expand(t1);
  free(t1);
  t1 = (char *)xmalloc(strlen(t2) + 3);
  t3 = t1;
  *t3++ = '{';
  for(t4=t2; *t4; t4++) {
     if(isknj(*t4)) {
	if(*(t4+1)) t4++;
	continue;
     }
     if(*t4 == '!')
	continue;
     if(*t4 == ';') {
	*t3++ = ',';
	continue;
     }
     *t3++ = *t4;
  }
  *t3++ = '}';
  *t3 = '\0';
  xputenv("TEXMF", t1);
  free(t1);
  free(t2);

  scrname[0] = '\0';

  if(strnicmp(av[0], "context", 7) == 0)
    kind = 1;
  if(strnicmp(av[0], "mtxrun", 6) == 0)
    kind = 2;

/* first search for script in the bin directory */

/* ruby (suffix .rb) */
  if(kind == 0) {
    if(!scrname[0]) {
      strcpy(fname, p);
      strcat(fname, "/");
      strcat(fname, av[0]);
      strcat(fname, ".rb");
      if(_access(fname, 0) == 0) {
        strcpy(scrname, fname);
      }
    }

/* lua (suffix .lua) */
    if(!scrname[0]) {
      strcpy(fname, p);
      strcat(fname, "/");
      strcat(fname, av[0]);
      strcat(fname, ".lua");
      if(_access(fname, 0) == 0) {
        strcpy(scrname, fname);
      }
    }

/* python (suffix .py) */
    if(!scrname[0]) {
      strcpy(fname, p);
      strcat(fname, "/");
      strcat(fname, av[0]);
      strcat(fname, ".py");
      if(_access(fname, 0) == 0) {
        strcpy(scrname, fname);
      }
    }

/* perl (suffix .pl) */
    if(!scrname[0]) {
      strcpy(fname, p);
      strcat(fname, "/");
      strcat(fname, av[0]);
      strcat(fname, ".pl");
      if(_access(fname, 0) == 0) {
        strcpy(scrname, fname);
      }
    }

/* search script under $TEXMF/scripts */

/* ruby */
    if(!scrname[0]) {
      strcpy(fname, av[0]);
      strcat(fname, ".rb");
      fullname = kpse_find_file(fname, kpse_texmfscripts_format, 0);
      if(fullname) {
        strcpy(scrname, fullname);
        free(fullname);
      }
    }

/* lua */
    if(!scrname[0]) {
      strcpy(fname, av[0]);
      fullname = kpse_find_file(fname, kpse_lua_format, 0);
      if(fullname == NULL) {
        strcat(fname, ".lua");
        fullname = kpse_find_file(fname, kpse_texmfscripts_format, 0);
      }
      if(fullname) {
        strcpy(scrname, fullname);
        free(fullname);
      }
    }

/* python */
    if(!scrname[0]) {
      strcpy(fname, av[0]);
      strcat(fname, ".py");
      fullname = kpse_find_file(fname, kpse_texmfscripts_format, 0);
      if(fullname) {
        strcpy(scrname, fullname);
        free(fullname);
      }
    }

/* perl */
    if(!scrname[0]) {
      strcpy(fname, av[0]);
      strcat(fname, ".pl");
      fullname = kpse_find_file(fname, kpse_texmfscripts_format, 0);
      if(fullname) {
        strcpy(scrname, fullname);
        free(fullname);
      }
    }

    if(!scrname[0]) {
      fprintf(stderr, "Failed to find script.\n");
      for(i=0; i < ac + 2; i++)
        free(argv[i]);
      exit (100);
    }
  }

/* mtxrun.lua */
  fullname = kpse_find_file("mtxrun", kpse_lua_format, 0);
  if(fullname == NULL) {
    fullname = kpse_find_file("mtxrun.lua", kpse_texmfscripts_format, 0);
  }

  if(fullname == NULL) {
    fprintf(stderr, "I cannot find mtxrun.lua.\n");
    exit (2);
  }

  strcpy(cmdname, fullname);
  free(fullname);

  if(kind == 1) {
    strcpy(argv[0], "texlua.exe");
    strcpy(argv[1], cmdname);
    strcpy(argv[2], "--script");
    strcpy(argv[3], "context");
    for(i=1; i < ac; i++)
      strcpy(argv[i+3], av[i]);
    argv[ac+3] = NULL;
  } else if(kind == 2) {
    strcpy(argv[0], "texlua.exe");
    strcpy(argv[1], cmdname);
    for(i=1; i < ac; i++)
      strcpy(argv[i+1], av[i]);
    argv[ac+1] = NULL;
  } else {
    strcpy(argv[0], "texlua.exe");
    strcpy(argv[1], cmdname);
    strcpy(argv[2], "--usekpse");
    strcpy(argv[3], "--execute");
    strcpy(argv[4], scrname);
    for(i=1; i < ac; i++)
      strcpy(argv[i+4], av[i]);
    argv[ac+4] = NULL;
  }

/*
  for(i=0; i < ac + 4; i++)
    fprintf(stderr, "%s ", argv[i]);
  fprintf(stderr, "\n");
  return (0);
*/

  ret = spawnvp(_P_WAIT, "texlua.exe", argv);

  for(i=0; i < ac + 4; i++)
    free(argv[i]);
  return ret;
}
