#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <ctype.h>
#include <string.h>
#include <knj.h>
#include <kpathsea/config.h>

#define SBUF 512

/*
file name in char *name is changed into
long name if it is '8.3' name
*/
void getlongname(char *name)
{
  HANDLE hnd;
  WIN32_FIND_DATA ffd;

  char buff[SBUF];
  char *p, *fp;

  strcpy(buff, name);

  for(p = buff; *p; p++) {
    if(isknj(*p)) {
      if(*(p+1)) p++;
      continue;
    }
    if(*p == '\\') *p = '/';
  }

  fp = buff;
  if(p = kstrrchr(fp, '/')) {
    p++;
    fp = p;
  }
  if(p = kstrrchr(fp, ':')) {
    p++;
    fp = p;
  }
  if((p = kstrrchr(fp, '.')) && !stricmp(p, ".exe")) *p = '\0';
  strcpy(name, fp);

  if(SearchPath(NULL, name, ".exe", SBUF, buff, &fp)) {
    if ((hnd = FindFirstFile(buff, &ffd)) == INVALID_HANDLE_VALUE) {
      fprintf(stderr,"%s is not found.\n", buff);
      exit (100);
    }
    FindClose(hnd);
    
    strcpy(buff, ffd.cFileName);
    fp = buff;
    if((p = kstrrchr(fp, '.')) && !stricmp(p, ".exe")) *p = '\0';
  }
  else {
    fprintf(stderr,"%s is not found.\n", name);
    exit (100);
  }

/*
  Crashes on Windows 98, so I don't realloc ...
  name = realloc(name, strlen(fp) + 2);
*/
  strcpy(name, fp);
  return;
}

/*
 path name in char *input is changed into the long
 name format and returned in char *buff.
 return value: 0 if failed
               1 if succeeded
*/

int getlongpath(char *buff, char *input, int len)
{
   HANDLE hnd;
   WIN32_FIND_DATA ffd;
   int  cnt = 0;
   char *p, *q, *r;

   buff[0] = '\0';
/*
temporarily change dir separators into back slashs
*/
   for(p = input; *p; p++) {
      if(isknj(*p) && *(p+1)) {
         p++;
         continue;
      }
      if(*p == '/') *p = '\\';
   }

   p = q = input;
   r = buff;

/*
UNC name
*/
   if(q[0] == '\\' && q[1] == '\\') {
      cnt += 2;
      if(cnt > len) return 0;
      buff[0] = '/';
      buff[1] = '/';
      p += 2;
      r += 2;
      while(*p != '\\' && *p) {
         cnt++;
         if(cnt > len) return 0;
         *r++ = *p++;
      }
      cnt++;
      if(cnt > len) return 0;
      *r++ = '/';
      if(*p) p++;
      while(*p != '\\' && *p) {
         cnt++;
         if(cnt > len) return 0;
         *r++ = *p++;
      }
      cnt++;
      if(cnt > len) return 0;
      *r++ = '/';
      *r= '\0';
      if(*p) p++;
/*
drive name
*/
   } else if(isalpha(q[0]) && q[1] == ':' && q[2] == '\\') {
      *r++ = q[0];
      *r++ = ':';
      *r++ = '/';
      *r = '\0';
      p += 3;
      cnt += 3;
      if(cnt > len) return 0;
   }

   for( ; *p; p++) {
      if(isknj(*p) && *(p+1)) {
         p++;
         continue;
      }
      if(*p == '\\') {
         *p = '\0';
         if((hnd = FindFirstFile(q, &ffd)) == INVALID_HANDLE_VALUE) {
            return 0;
         }
         FindClose(hnd);
         cnt += strlen(ffd.cFileName);
         cnt++;
         if(cnt > len) return 0;
         strcat(buff, ffd.cFileName);
         strcat(buff, "/");
         *p = '\\';
      }
   }

/*
file itself
*/
   if((hnd = FindFirstFile(q, &ffd)) == INVALID_HANDLE_VALUE) {
      return 0;
   }
   FindClose(hnd);
   cnt += strlen(ffd.cFileName);
   if(cnt > len) return 0;
   strcat(buff, ffd.cFileName);
   return 1;
}
