/* knj.c */
#include <knj.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>

int isknj(int c)
{
  c &= 0xff;
  return((c>=0x81 && c<=0x9f) || (c>=0xe0 && c<=0xfc));
}

int isknj2(int c)
{
  c &= 0xff;
  return(c>=0x40 && c<=0xfc && c!=0x7f);
}

char *kstrchr(char *s, int c)
{
  while(*s) {
    if(isknj(*s) && *(s+1)) {
      s += 2;
      continue;
    }
    if(*s == c)
	return s;
    s++;
  }
  return NULL;
}

char *kstrrchr(char *s, int c)
{
  char *p;
  for(p=NULL; *s; s++) {
    if(isknj(*s) && *(s+1)) {
      s++;
      continue;
    }
    if(*s == c)
      p = s;
  }
  return p;
}

#ifdef TEST
int main(void)
{
  char *s;
  s = kstrchr("f.xyz.exe", '.');
  printf("%s\n", s);
  s = kstrrchr("f.xyz.exe", '.');
  printf("%s\n", s);
  s = kstrchr("fxyzexe", '.');
  printf("%s\n", s);
  s = kstrrchr("fxyzexe", '.');
  printf("%s\n", s);
  s = kstrchr("\\\Z", '\\');
  printf("%s\n", s);
  s = kstrrchr("Z\\\", '\\');
  printf("%s\n", s);
  s = kstrchr("\Z", '\\');
  printf("%s\n", s);
  s = kstrrchr("Z\", '\\');
  printf("%s\n", s);
  return 0;
}
#endif
