#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "uniblock.h"

#ifdef WIN32
#include <fcntl.h>
#include <io.h>
#include <malloc.h>
#endif

#include <kpathsea/kpathsea.h>

FILE *vfp,*afp=NULL;
char *atfmname,*vtfmname,*afmname,*vfname,*kanatfm,*jistfm,*ucsqtfm;
int kanatume=-1,chotai=0,baseshift=0,minute=0,useset3=0,hankana=0,fidzero=0;
long ucs=0;

FILE *vfopen();
void usage();

int
main(int argc, char **argv)
{
	int i,j,ib;
	long ch;
	char *fpath;

#ifdef WIN32
	getlongname(argv[0]);
#endif
	kpse_set_progname(argv[0]);

	if (argc < 3) {
		usage();
		exit(0);
	}

	argv++;

	for (;**argv=='-';argv++) {
		switch ((*argv)[1]) {
		case 'k':
			if ((*argv)[2]!='\0') {
				kanatume = atoi(&(*argv)[2]);
			}
			else {
				kanatume = atoi(*(++argv));
			}
			break;
		case 'K':
			if ((*argv)[2]!='\0') {
				kanatfm = strdup(&(*argv)[2]);
			}
			else {
				kanatfm = strdup(*(++argv));
			}
			break;
		case 'C':
			chotai=1;
			break;
		case 'a':
			if ((*argv)[2]!='\0') {
				afmname = strdup(&(*argv)[2]);
			}
			else {
				afmname = strdup(*(++argv));
			}
			if ((fpath=kpse_find_file(afmname,
			     kpse_afm_format, 0))==NULL) {
				fprintf(stderr,"no AFM file, %s.\n",afmname);
#ifdef WIN32
				exit(100);
#else
				exit(-1);
#endif
			}
			afp = fopen(fpath, "r");
			free(fpath);
			break;
		case 'b':
			if ((*argv)[2]!='\0') {
				baseshift = atoi(&(*argv)[2]);
			}
			else {
				baseshift = atoi(*(++argv));
			}
			break;
		case 'm':
			minute=1;
			break;
		case 'u':
			argv++;
			if (!strcmp(*argv,"gb"))
				ucs = ENTRY_G;
			else if (!strcmp(*argv,"cns"))
				ucs = ENTRY_C;
			else if (!strcmp(*argv,"jisq"))
				ucs = ENTRY_JQ;
			else if (!strcmp(*argv,"jis"))
				ucs = ENTRY_J;
			else if (!strcmp(*argv,"ks"))
				ucs = ENTRY_K;
			else {
				fprintf(stderr,"Charset is not set\n");
				ucs = ENTRY_NO;
			}
			break;
		case '3':
			useset3=1;
			break;
		case 'J':
			if ((*argv)[2]!='\0') {
				jistfm = strdup(&(*argv)[2]);
			}
			else {
				jistfm = strdup(*(++argv));
			}
			break;
		case 'U':
			if ((*argv)[2]!='\0') {
				ucsqtfm = strdup(&(*argv)[2]);
			}
			else {
				ucsqtfm = strdup(*(++argv));
			}
			break;
		case 'H':
			hankana=1;
			break;
		case 'i':
			fidzero=1;
			break;
		default:
			usage();
			exit(0);
		}
	}

	if (kanatume>=0 && !afp) {
		fprintf(stderr,"No AFM file for kanatume.\n");
#ifdef WIN32
		exit(100);
#else
		exit(-1);
#endif
	}

	atfmname = malloc(strlen(*argv)+4);
	strcpy(atfmname,*argv);

	vfname = malloc(strlen(*argv)+4);
	strcpy(vfname,*argv);
	for (i = strlen(vfname)-1 ; i >= 0 ; i--) {
#ifdef WIN32
		if ((vfname[i] == '/') || (vfname[i] == '\\')) {
#else
		if (vfname[i] == '/') {
#endif
			vfname = &vfname[i+1];
			break;
		}
	}
	fpath = strrchr(vfname, '.');
#ifdef WIN32
	if (fpath && !stricmp(&vfname[strlen(vfname)-4],".tfm")) {
#else
	if (fpath && !strcmp(&vfname[strlen(vfname)-4],".tfm")) {
#endif
		vfname[strlen(vfname)-4] = '\0';
	}
	strcat(vfname,".vf");

	argv++;

	vtfmname = strdup(*argv);
	fpath = strrchr(vtfmname, '.');
#ifdef WIN32
	if (fpath && !stricmp(&vtfmname[strlen(vtfmname)-4],".tfm")) {
#else
	if (fpath && !strcmp(&vtfmname[strlen(vtfmname)-4],".tfm")) {
#endif
		vtfmname[strlen(vtfmname)-4] = '\0';
	}

	tfmget(atfmname);

	maketfm(vtfmname);

	if (kanatfm) {
	        fpath = strrchr(kanatfm, '.');
#ifdef WIN32
		if (fpath && !stricmp(&kanatfm[strlen(kanatfm)-4],".tfm")) {
#else
		if (fpath && !strcmp(&kanatfm[strlen(kanatfm)-4],".tfm")) {
#endif
			kanatfm[strlen(kanatfm)-4] = '\0';
		}
		maketfm(kanatfm);
	}

	if (jistfm) {
		if (!strcmp(&jistfm[strlen(jistfm)-4],".tfm")) {
			jistfm[strlen(jistfm)-4] = '\0';
		}
		maketfm(jistfm);
	}

	if (ucsqtfm) {
		if (!strcmp(&ucsqtfm[strlen(ucsqtfm)-4],".tfm")) {
			ucsqtfm[strlen(ucsqtfm)-4] = '\0';
		}
		maketfm(ucsqtfm);
	}

	vfp = vfopen(vfname);

	if (ucs) {
		ib=0;
		for (i=0;i<(useset3+1);i++)
			for (j=0;j<65536;j++) {
				ch=i*2*65536+j;
				if (search_cjk_entry(&ib,ch,ucs))
					writevfu(ch,vfp);
			}
	} else {
		for (i=0;i<94;i++)
			for (j=0;j<94;j++)
				writevf((0x21+i)*256+(0x21+j),vfp);
	}

	vfclose(vfp);

	return 0;
}

void
usage(void)
{
	fprintf(stderr,"MAKEJVF ver.1.1a -- make Japanese VF file.\n");
	fprintf(stderr,"%% makejvf [<options>] <TFMfile> <PSfontTFM>\n");
	fprintf(stderr,"options:\n");
	fprintf(stderr,"-C           ̃[h\n");
	fprintf(stderr,"-K <TFMfile> 񊿎pɍ쐬PStHgTFM\n");
	fprintf(stderr,"-b <l>    x[XC␳\n");
	fprintf(stderr,"             ̍1000ƂĐŎw\n");
	fprintf(stderr,"             vXŕA}CiXŕオ\n");
	fprintf(stderr,"-m           cɃNI[g(fh)̑Ƀ~j[g()gp\n");
	fprintf(stderr,"-a <AFMfile> AFMt@CiȋlߎɎgpj\n");
	fprintf(stderr,"-k <l>    ȋl߃}[Ww\n");
	fprintf(stderr,"             1000ƂĐŎwB-aIvVƋɎgp\n");
	fprintf(stderr,"-J <TFMfile> JIS encoded PS font TFM name for quote, double quote with ucs mode (experimental)\n");
	fprintf(stderr,"-U <TFMfile> UCS encoded PS font TFM name for quote, double quote with ucs mode (experimental)\n");
	fprintf(stderr,"-u gb        ucs mode (GB)  (experimental)\n");
	fprintf(stderr,"-u cns       ucs mode (CNS) (experimental)\n");
	fprintf(stderr,"-u jis       ucs mode (JIS) (experimental)\n");
	fprintf(stderr,"-u jisq      ucs mode (JIS, quote only) (experimental)\n");
	fprintf(stderr,"-u ks        ucs mode (KS)  (experimental)\n");
	fprintf(stderr,"-3           use set3 (experimental)\n");
	fprintf(stderr,"-H           use half-width katakana (experimental)\n");
	fprintf(stderr,"-i           font ID from No.0 (experimental)\n");
}
