/*
   kanji.h: Handling 2byte char, and so on.
*/
#ifndef KANJI_H
#define KANJI_H
#include "cpascal.h"
#include "ptexhelp.h"
#include <ptexenc/ptexenc.h>
#include <ptexenc/unicode.h>

#ifndef KANJI
#define KANJI
#endif

/* functions */
#define XXHi(x) BYTE1(x)
#define XHi(x) BYTE2(x)
#define Hi(x) BYTE3(x)
#define Lo(x) BYTE4(x)

extern integer check_kanji P2H(integer c,integer m);
#define checkkanji check_kanji
extern boolean is_kanji P1H(integer c);
#define iskanji is_kanji
extern boolean is_char_ascii P1H(integer c);
#define ischarascii is_char_ascii
extern boolean is_wchar_ascii P1H(integer c);
#define iswcharascii is_wchar_ascii
extern boolean ismultiprn P1H(integer c);
extern integer calc_pos P1H(integer c);
#define calcpos calc_pos
extern integer kcatcodekey P1H(integer c);
extern integer multilenbuffchar P1H(integer c);
#define setptexencuptex() set_enc_string("utf8", "uptex");

/* number of rest of multi-char for kcode_pos */
#define nrestmultichr(x)  ( (x)!=0 ? ((x) / 8) + 2 - ((x) % 8) : -1 )

#ifndef PRESERVE_PUTC
#undef putc
#define putc(c,fp) putc2(c,fp)
#endif /* !PRESERVE_PUTC */

#ifdef TeX
#undef TEXMFPOOLNAME
#undef TEXMFENGINENAME
#define TEXMFPOOLNAME   "uptex.pool"
#define TEXMFENGINENAME "uptex"
#endif /* TeX */

#ifdef MP
#undef TEXMFPOOLNAME
#undef TEXMFENGINENAME
#define TEXMFPOOLNAME   "upjmp.pool"
#define TEXMFENGINENAME "upjmpost"
#endif /* MP */

#endif /* not KANJI_H */
