/* ptexhelp.h: for the --help option"
*/
#ifndef PTEXHELP_H
#define PTEXHELP_H
#define HELP_H

#ifdef TeX
/*  ptexextra.h */
#undef TEXMFPOOLNAME
#undef TEXMFENGINENAME
#define TEXMFPOOLNAME   "uptex.pool"
#define TEXMFENGINENAME "uptex"
#endif /* TeX */

#ifdef UPTFTOPL
string based_prog_name = "upTFtoPL";
const_string PTEXTFTOPLHELP[] = {
"Usage: uptftopl [option] tfmfile [plfile]",
"",
"  -verbose               output progress reports.",
"  -version               print version information and exit.",
"  -help                  print this message and exit.",
"  -sjis-terminal         always output to stdout and stderr by sjis.",
"  -kanji={jis|euc|sjis|utf8|uptex}",
"                         plfile kanji code.",
NULL };
#endif /* UPTFTOPL */

#ifdef UPPLTOTF
string based_prog_name = "upPLtoTF";
const_string PTEXPLTOTFHELP[] = {
"Usage: uppltotf [option] plfile [tfmfile]",
"",
"  -verbose               output progress reports.",
"  -version               print version information and exit.",
"  -help                  print this message and exit.",
"  -sjis-terminal         always output to stdout and stderr by sjis.",
"  -kanji={jis|euc|sjis|utf8|uptex}",
"                         plfile kanji code.",
NULL };
#endif /* UPPLTOTF */

#ifdef UPBIBTEX
string based_prog_name = "upBibTeX";
const_string UPBIBTEXHELP[] = {
"Usage: upbibtex [option] auxfile",
"",
"  -min-crossrefs=INTEGER     minimum number of cross-refs required",
"                             for automatic cite_list inclusion (default 2).",
"  -terse                     do silently.",
"  -version                   print version information and exit.",
"  -help                      print this message and exit.",
"  -sjis-terminal             always output to stdout and stderr by sjis.",
"  -kanji={jis|euc|sjis|utf8|uptex} kanji code for output-file.",
NULL };
#endif /* UPBIBTEX */

#ifdef UPDVITYPE
string based_prog_name = "upDVItype";
const_string PDVITYPEHELP[] = {
"Usage: updvitype [option] dvifile",
"",
"  -dpi=REAL                  assumed device resolution in pixels per inch",
"                             (default 300.0).",
"  -magnification=INTEGER     overrride the postamble's magnification.",
"  -max-pages=INTEGER         maximum number of pages (default 1000000).",
"  -output-level=1..4         verbosity level.",
"                                 1: terse, 2: medium-level, 3: verbose,",
"                                 4: plus check for postamble(default).",
"  -page-start=PAGE           type, e.g., `1.*.-5' to specify the first page",
"                             with \\count0=1, \\count2=4.",
"                             (see the TeX book chapter 15).",
"  -show-opcodes              show opcodes in dicimal.",
"  -sjis-terminal             always output to stdout and stderr by sjis.",
"  -kanji={jis|euc|sjis|utf8|uptex} kanji code for output-file.",
"  -version                   print version information and exit.",
"  -help                      print this message and exit.",
NULL };
#endif /* UPDVITYPE */
#endif /* PTEXHELP_H */
