/* Japanese support (A. Kakuto 1998/11/12) */
#if defined (SJIS) || defined (EUC)
#ifndef KANJI
#define KANJI 1
#endif
#endif

#ifdef KANJI
/* First byte of SJIS or EUC character */
int iskanji(int c)
{
    c &= 0xff;
#ifdef SJIS
    return((c>=0x81 && c<=0x9f) || (c>=0xe0 && c<=0xfc));
#else
    return(c>=0xa1 && c<=0xfe);
#endif
}
int this_is_kanji = 0;
int kanji_space = 0;
#endif

#ifdef KANJI
int iskanji2(int c)
{
    c &= 0xff;
#ifdef SJIS
    return(c>=0x40 && c<=0xfc && c!=0x7f);
#else
    return(c>=0xa1 && c<=0xfe);
#endif
}
#endif

#ifdef KANJI
int gyoto(int a, int b)
{
  a &= 0xff;
  b &= 0xff;
#ifdef SJIS
  return (a == 0x81 && ((b >= 0x41 && b <= 0x49) ||
		       (b == 0x4c) ||
		       (b >= 0x52 && b <= 0x56) ||
		       (b == 0x5e) ||
		       (b == 0x5f) ||
		       (b == 0x66) ||
		       (b == 0x68) ||
		       (b == 0x6a) ||
		       (b == 0x6c) ||
		       (b == 0x6e) ||
		       (b == 0x70) ||
		       (b == 0x72) ||
		       (b == 0x74) ||
		       (b == 0x76) ||
		       (b == 0x78) ||
		       (b == 0x7a) ||
		       (b == 0x8c) ||
		       (b == 0x8d))
	  );
#else
  return (a == 0xa1 && ((b >= 0xa2 && b <= 0xaa) ||
		       (b == 0xad) ||
		       (b >= 0xb3 && b <= 0xb7) ||
		       (b == 0xbf) ||
		       (b == 0xc0) ||
		       (b == 0xc7) ||
		       (b == 0xc9) ||
		       (b == 0xcb) ||
		       (b == 0xcd) ||
		       (b == 0xcf) ||
		       (b == 0xd1) ||
		       (b == 0xd3) ||
		       (b == 0xd5) ||
		       (b == 0xd7) ||
		       (b == 0xd9) ||
		       (b == 0xdb) ||
		       (b == 0xec) ||
		       (b == 0xed))
	  );
#endif
}
#endif
