/*
 * Copyright (C) 2007 Keith Stribley
 * 
 * Distributable under the terms of either the Common Public License or the
 * GNU Lesser General Public License, as specified in the LICENSING.txt file.
 *
 */

package org.sil.graphite.swing;

import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Dimension;
import java.awt.font.GlyphVector;
import java.awt.font.FontRenderContext;
import java.awt.font.LineMetrics;

import javax.swing.JLabel;
import javax.swing.text.View;

import org.sil.graphite.awt.GraphiteAwtFont;
/**
 *
 * @author keith
 */
public class GrLabel extends JLabel
{
  /**
     * 
     */
    private static final long serialVersionUID = -8269902987772610638L;
double graphiteWidth = Double.NaN;
  /** Creates a new instance of GrLabel */
  public GrLabel()
  {
  }
  public void paint(Graphics graphics)
  {
    View view = (View) this.getClientProperty("html");
	if (view != null) 
    {
      PaintHelper.preparePaint(view, (Graphics2D)graphics);
      super.paint(graphics);
    }
    else if (getFont() instanceof GraphiteAwtFont)
    {
      GraphiteAwtFont font = (GraphiteAwtFont)getFont();
      Graphics2D g2d = (Graphics2D)graphics;
      FontRenderContext frc = g2d.getFontRenderContext();
      GlyphVector gv = font.layoutGlyphVector(frc, getText().toCharArray(), 
          0, getText().length(), Font.LAYOUT_LEFT_TO_RIGHT);
      FontMetrics fm = this.getFontMetrics(font);
      graphiteWidth = gv.getGlyphPosition(gv.getNumGlyphs()).getX();
      g2d.drawGlyphVector(gv, 0, fm.getAscent() + fm.getLeading()); 
    }
    else super.paint(graphics);
  }
  public Dimension getPreferredSize()
  {
    Dimension dim = super.getPreferredSize();
    //System.out.println("JLabel " + dim + " gr " + graphiteWidth);
    if (!Double.isNaN(graphiteWidth))
    {
      java.awt.Insets insets = this.getInsets();
      dim.setSize(graphiteWidth + insets.left + insets.right, dim.getHeight());
    }
    return dim;
  }
}
