/*
 * Copyright (C) 2005, 2007 Keith Stribley
 * 
 * Distributable under the terms of either the Common Public License or the
 * GNU Lesser General Public License, as specified in the LICENSING.txt file.
 *
 */

package org.sil.graphite.test;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.GraphicsEnvironment;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JTextPane;
import javax.swing.LookAndFeel;
import javax.swing.SwingConstants;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.text.JTextComponent;
//import javax.swing.JTextPane;


import org.sil.graphite.awt.GraphiteAwtFont;
import org.sil.graphite.awt.GraphiteFontManager;
import org.sil.graphite.swing.*;
import org.sil.graphite.ui.GrLookAndFeel;

/**
 *
 * @author  keith
 */
public class GraphiteTest extends javax.swing.JDialog implements ActionListener
{
  /**
     * 
     */
  private static final long serialVersionUID = 8222114564538211124L;
  //private String testText = "\u1005\u1000\u1039\u1000\u102f\u1000\u103c\u1031\u102c\u1004\u103a\u1000\u102c" +
  //    "\u0020\u101e\u1004\u103a\u1039\u1001\u103b\u102d\u102f\u1004\u103a\u1038";
  private String [] testText = {
      "\u1019\u103c\u1014\u103a\u1019\u102c\u1015\u102d\u1010\u1031\u102c\u1000\u103a" + 
      "\u1016\u1031\u102c\u1004\u103a\u1037\u1005\u1019\u103a\u1038" + 
      "\u1001\u103b\u1004\u103a\u1038",
      "\u0061\u0308\u0303\u0301\u0020\u0020\u025b\u0303\u0308\u0300\u0020\u0020" +
      "\u0269\u0302\u0301\u0020\u0254\u0303\u0302\u0020\u0020" + 
      "\u0289\u0304\u0308\u0020\u0260\u032a\u0308\u0325"
  };
  private Font [] testFont = {
      new Font("Padauk", Font.PLAIN, 16), new Font("Doulos SIL", Font.PLAIN, 16)
  };
  private Font font = null;
  private JPanel mainPanel = null;
  private JTextPane gTextPane = null;
  private List <JComponent> components = new Vector<JComponent>();
  //private JTextPane jTextPane = null;
  /** Creates new form GraphiteTest */
  public GraphiteTest(java.awt.Frame parent, boolean modal, Font aFont)
  {
    super(parent, modal);
    initComponents();
    
    font = aFont;
    getContentPane().setLayout(new BorderLayout());
    mainPanel = new JPanel();
    mainPanel.setLayout(new GridLayout(3,4));
    
//    Graphics graphics = this.getGraphics();
    JLabel jLabel = new JLabel(testText[0]);
    jLabel.setFont(font);
    mainPanel.add(jLabel);
    components.add(jLabel);

    gTextPane = new JTextPane();
    getContentPane().add(gTextPane);
    gTextPane.setFont(font);
    gTextPane.setText(testText[0]);
    //GraphiteTextPanel(font, testText);
    mainPanel.add(gTextPane);
    components.add(gTextPane);
    
    JLabel gLabel = new JLabel();
    gLabel.setHorizontalAlignment(SwingConstants.CENTER);
    gLabel.setEnabled(false);
    gLabel.setFont(font);
    gLabel.setText(testText[0]);
    mainPanel.add(gLabel);
    components.add(gLabel);
    
    Object [] comboData = testText;
    JComboBox combo = new JComboBox(comboData);
    combo.setEditable(true);
    combo.setFont(font);
    combo.addActionListener(this);
    mainPanel.add(combo);
    components.add(combo);
    
    JComboBox combo2 = new JComboBox(comboData);
    combo2.setEditable(false);
    combo2.setFont(font);
    combo2.addActionListener(this);
    mainPanel.add(combo2);
    components.add(combo2);
    
    JButton button = new JButton(testText[0]);
    button.setFont(font);
    button.addActionListener(this);
    mainPanel.add(button);
    components.add(button);
    
    JTextComponent text = new GrTextPane();
    text.setText(testText[0]);
    text.setFont(font);
    mainPanel.add(text);
    components.add(text);

//    JTextComponent text2 = new JTextField();
//    text2.setText(testText);
//    text2.setFont(font);
//    getContentPane().add(text2);
    
    JMenuBar bar = new JMenuBar();
    bar.setLayout(new FlowLayout(FlowLayout.LEADING));
    getContentPane().add(bar, BorderLayout.NORTH);
    
    JMenuItem menu = new JMenuItem();
    menu.setText(testText[0]);
    menu.setFont(font);
    bar.add(menu);
    components.add(menu);
    
    JMenuItem menu2 = new JMenuItem();
    menu2.setText(testText[0]);
    menu2.setFont(font);
    menu2.setEnabled(false);
    bar.add(menu2);
    components.add(menu2);
    bar.add(new JMenuItem());
    
    getContentPane().add(mainPanel, BorderLayout.CENTER);

    this.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
    this.setSize(500, 400);
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents()//GEN-BEGIN:initComponents
  {

    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    addWindowListener(new java.awt.event.WindowAdapter()
    {
      public void windowClosed(java.awt.event.WindowEvent evt)
      {
        formWindowClosed(evt);
      }
    });

    pack();
  }//GEN-END:initComponents

  private void formWindowClosed(java.awt.event.WindowEvent evt)//GEN-FIRST:event_formWindowClosed
  {//GEN-HEADEREND:event_formWindowClosed
    // TODO add your handling code here:
    GraphiteFontManager.dispose();
    System.exit(0);
  }//GEN-LAST:event_formWindowClosed
  
  public void paint(Graphics graphics)
  {
    super.paint(graphics);
  }
  
  /**
   * @param args the command line arguments
   */
    public static void main(String args[])
    {
        System.setProperty("awt.useSystemAAFontSettings", "lcd");
        // this enables/disables graphite support
        UIManager.addAuxiliaryLookAndFeel( new GrLookAndFeel());

        java.awt.EventQueue.invokeLater(new Runnable()
        {
          public void run()
          {
            Font theFont = new Font("Padauk", Font.PLAIN, 16);
            new GraphiteTest(new javax.swing.JFrame(), true, theFont).setVisible(true);
          }
        });
  }
  
    protected void setLabels(String text)
    {
        Iterator <JComponent>i = components.iterator();
        while(i.hasNext())
        {
            JComponent c = i.next();
            if (c instanceof JTextComponent)
            {
                ((JTextComponent)c).setText(text);
            }
            else if (c instanceof JLabel)
            {
                ((JLabel)c).setText(text);
            } 
            else if (c instanceof JButton)
            {
                ((JButton)c).setText(text);
            }
            else if (c instanceof JComboBox)
            {
                ((JComboBox)c).setSelectedItem(text);
            }
            else if (c instanceof JMenuItem)
            {
                ((JMenuItem)c).setText(text);
            }
        }
    }
    
    protected void setComponentsFont(Font newFont)
    {
        this.font = newFont;
        Iterator <JComponent>i = components.iterator();
        while(i.hasNext())
        {
            JComponent c = i.next();
            if (c instanceof JTextComponent)
            {
                ((JTextComponent)c).setFont(font);
            }
            else if (c instanceof JLabel)
            {
                ((JLabel)c).setFont(font);
            } 
            else if (c instanceof JButton)
            {
                ((JButton)c).setFont(font);
            }
            else if (c instanceof JComboBox)
            {
                ((JComboBox)c).setFont(font);
            }
            else if (c instanceof JMenuItem)
            {
                ((JMenuItem)c).setFont(font);
            }
        }
    }
    
  // Variables declaration - do not modify//GEN-BEGIN:variables
  // End of variables declaration//GEN-END:variables

    public void actionPerformed(ActionEvent e)
    {
        if (e.getSource() instanceof JComboBox)
        {
            JComboBox combo = ((JComboBox)e.getSource());
            int item = combo.getSelectedIndex();
            if (item > -1)
            {
                setComponentsFont(testFont[item]);
            }
            setLabels(combo.getSelectedItem().toString());
        }
        if (e.getSource() instanceof JButton)
        {
            Font [] fontList = GraphicsEnvironment.
                getLocalGraphicsEnvironment().getAllFonts();
            
            List<Font> grFontList = new Vector<Font>();
            
            for (int i = 0; i<fontList.length; i++)
            {
                if (GraphiteFontManager.isGraphite(fontList[i]))
                    grFontList.add(fontList[i]);
            }
            if (grFontList.size() > 0)
            {
                Font selectedValue = (Font) JOptionPane.showInputDialog(this,
                        "Choose a font", "Graphite Fonts",
                        JOptionPane.INFORMATION_MESSAGE, null,
                        grFontList.toArray(), grFontList.get(0));
                if (selectedValue != null)
                {
                    Font newFont = selectedValue.deriveFont(selectedValue.getSize(), (float)16.0);
                    setComponentsFont(newFont);
                }
            }
            else
            {
                JOptionPane.showMessageDialog(this, "No graphite fonts were found");
            }
        }
    }
}
