/*
 * Copyright (C) 2007 Keith Stribley
 * 
 * Distributable under the terms of either the Common Public License or the
 * GNU Lesser General Public License, as specified in the LICENSING.txt file.
 *
 */
package org.sil.graphite.ui;

import javax.swing.AbstractButton;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.LookAndFeel;
import javax.swing.UIDefaults;
import javax.swing.UIManager;
import javax.swing.plaf.ComponentUI;
import javax.swing.plaf.metal.MetalLookAndFeel;
import javax.swing.text.JTextComponent;

/**
 * @author keith
 *
 */
public class GrLookAndFeel extends LookAndFeel
{
    UIDefaults defaults = null;
    LookAndFeel parent = null;
    
    
    public GrLookAndFeel()
    {
        
    }
    
    /* (non-Javadoc)
     * @see javax.swing.LookAndFeel#getDescription()
     */
    @Override
    public String getDescription()
    {
        return "Adds support for Graphite smart fonts";
    }

    /* (non-Javadoc)
     * @see javax.swing.LookAndFeel#isNativeLookAndFeel()
     */
    @Override
    public boolean isNativeLookAndFeel()
    {
        
        return false;
    }

    /* (non-Javadoc)
     * @see javax.swing.LookAndFeel#isSupportedLookAndFeel()
     */
    @Override
    public boolean isSupportedLookAndFeel()
    {
        
        return true;
    }

    
    /* (non-Javadoc)
     * @see javax.swing.LookAndFeel#getDefaults()
     */
    @Override
    public UIDefaults getDefaults()
    {
        UIDefaults table = new GrUIDefaults();
        Object [] uiDefaults = {
                "TextUI", org.sil.graphite.ui.GrTextUI.class,
                "ButtonUI", org.sil.graphite.ui.GrButtonUI.class,
                "LabelUI", org.sil.graphite.ui.GrLabelUI.class
        };
        //table.putAll(super.getDefaults());
        return table;
    }
    
    class GrUIDefaults extends UIDefaults
    {

        /* (non-Javadoc)
         * @see javax.swing.UIDefaults#getUIError(java.lang.String)
         */
        @Override
        protected void getUIError(String msg)
        {
            //super.getUIError(msg);
        }

        /* (non-Javadoc)
         * @see javax.swing.UIDefaults#getUI(javax.swing.JComponent)
         */
        @Override
        public ComponentUI getUI(JComponent target)
        {
            ComponentUI ui = super.getUI(target);
            if (target instanceof JTextComponent)
                return new GrTextUI();
            else if (target instanceof JLabel)
                return new GrLabelUI();
            else if (target instanceof AbstractButton)
                return new GrButtonUI();
            return ui;
        }

        /* (non-Javadoc)
         * @see javax.swing.UIDefaults#getUIClass(java.lang.String, java.lang.ClassLoader)
         */
        @Override
        public Class<? extends ComponentUI> getUIClass(String uiClassID, ClassLoader uiClassLoader)
        {
            // TODO Auto-generated method stub
            Class<? extends ComponentUI> uiComponent = super.getUIClass(uiClassID, uiClassLoader); 
            return uiComponent;
        }

        private static final long serialVersionUID = 3261313273256612020L;

    }

    /* (non-Javadoc)
     * @see javax.swing.LookAndFeel#getID()
     */
    @Override
    public String getID()
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.swing.LookAndFeel#getName()
     */
    @Override
    public String getName()
    {
        // TODO Auto-generated method stub
        return null;
    }
    
}
